<template>
  <!-----Tabla---->
  <v-simple-table>
    <template v-slot:default>
      <!----Cabecera de la tabla---->
      <thead>
        <tr>
          <th class="text-center">Nombre</th>
          <th class="text-center">Apellido</th>
          <th class="text-center">Email</th>
          <th class="text-center">Teléfono</th>
          <th class="text-center">Edad</th>
          <th class="text-center">Acciones</th>
        </tr>
      </thead>
      <!-----Cuerpo de la tabla----->
      <tbody>
        <tr v-for="item in personas" :key="item._id">
          <td>{{ item.nombre }}</td>
          <td>{{ item.apellido }}</td>
          <td>{{ item.email }}</td>
          <td>{{ item.telefono }}</td>
          <td>{{ item.edad }}</td>
          <!----Columna de acciones--->
          <td>
            <v-btn class="ma-2" outlined color="indigo" v-on:click="actualizar(item)">
              Actualizar
            </v-btn>
            <v-btn class="ma-2" outlined color="error" v-on:click="eliminar(item._id)"><!---@click-->
              Eliminar
            </v-btn>
          </td>
        </tr>
      </tbody>
    </template>
  </v-simple-table>
</template>

<script>
import store from "../store/index.js";

export default {
  methods:{
    eliminar(id){
      console.log("Eliminar-> ", id);
      let obj = { id };
      store.dispatch('eliminarPersona', obj).then(()=>{
        //realiza solicitud get al backend
        store.dispatch("cargarPersonas");
      });
    },
    actualizar(objPersona){
      console.log("Estoy en el hijo-> ", objPersona);
      //Emitir al padre el objeto persona
      this.$emit('objPersona', objPersona);
    }
  },
  created: () => {
    //realiza solicitud get al backend
    store.dispatch("cargarPersonas");
  },
  //Propiedades computadas
  computed: {
    personas: () => {
      return store.state.personas;
    },
  },
};
</script>

<style>
</style>